package task1;

/**
 * The basic Selection Sort algorithm.
 *
 * @param <T> Element type.
 */
public final class MysterySort<T extends Comparable<T>>
    implements SortingAlgorithm<T> {

  // is a less than b?
  private boolean less(T a, T b) {
    return a.compareTo(b) < 0;
  }

  @Override
  public void sort(IndexedList<T> indexedList) {
    boolean swapped;
    int remaining = indexedList.length();
    do {
      swapped = false;
      for (int i = 0; i < remaining - 2; i++) {
        swapped = swap(indexedList, i, i + 1) || swapped;
      }

      if (!swapped) {
        break;
      }

      swapped = false;
      for (int j = remaining - 2; j > 0; j--) {
        swapped = swap(indexedList, j, j + 1) || swapped;
      }

      remaining--;
    } while (swapped);
  }

  // Pre: i & j are valid indices.
  // Post: elements at i & j are swapped if they were not in desired order.
  private boolean swap(IndexedList<T> indexedList, int i, int j) {
    if (less(indexedList.get(j), indexedList.get(i))) {
      T t = indexedList.get(i);
      indexedList.put(i, indexedList.get(j));
      indexedList.put(j, t);
      return true;
    }
    return false;
  }

  @Override
  public String name() {
    return "Mystery Sort";
  }
}