package task1;

/**
 * The essence of a sorting algorithm.
 *
 * @param <T> Element type.
 */
public interface SortingAlgorithm<T extends Comparable<T>> {
  /**
   * Sort a collection.
   *
   * @param indexedList collection to sort.
   */
  void sort(IndexedList<T> indexedList);

  /**
   * Name of algorithm.
   *
   * @return Name of algorithm.
   */
  String name();
}