package task2;

/**
 * CumulativeMaxList ADT.
 */
public interface CumulativeMaxList {

  /**
   * Change the value at the given (1-based) positions index.
   *
   * @param index representing a position in this list.
   *              Pre: 1 <= index <= length()
   * @param value to be written at the given index.
   *              Pre: value >= 1
   *              Post: this.get(index) == value
   */
  void insertAt(int index, int value);

  /**
   * Retrieve the value stored at the given (1-based) positions index.
   *
   * @param index representing a position in this list.
   *              Pre: 1 <= index <= length()
   * @return value at the given index.
   */
  int get(int index);

  /**
   * Get the cumulative maximum at the given (1-based) positions index.
   *
   * @param index representing a position in this list.
   *              Pre: 1 <= index <= length()
   * @return Cumulative max at the given index.
   */
  int getMaxAt(int index);

  /**
   * Get the number of elements in this list.
   *
   * @return the length
   *         Inv: length() >= 0
   */
  int length();
}
