package task3;

/**
 * Represents a Book.
 */
public class Book implements Comparable<Book> {
  private int numPages;

  /**
   * Construct a book.
   * @param numPages number of pages of this book.
   */
  public Book(int numPages) {
    this.numPages = numPages;
  }

  /**
   * Get number of pages of this book.
   * @return number of pages of this book.
   */
  public int getNumPages() {
    return numPages;
  }

  @Override
  public int compareTo(Book book) {
    return numPages - book.numPages;
  }

  @Override
  public String toString() {
    return String.format("%d", numPages);
  }
}
